
// ScrollMBDemo.java
// Andrew Davison, ad@fivedots.coe.psu.ac.th, August 2005

/* A test rig holding a text field for entering messages,
   and a ScrollableMessagesBox object which shows the messages
   previously entered.

   The size of the ScrollableMessagesBox is constrained by the size
   of the text field.
*/


import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;


public class ScrollMBDemo extends MIDlet 
                        implements CommandListener 
{
  private Display display;
  private Form form;
  private TextField msgTF;
  private ScrollableMessagesBox scroller;
  private Command exitCmd, sendCmd;


  public ScrollMBDemo() 
  {
    form = new Form("Scrollable Messages Box Example");

    // get the form's dimensions
    int width = form.getWidth();
    int height = form.getHeight();

    msgTF = new TextField("Enter:", null, 15, 0);
    int msgTFHeight = msgTF.getPreferredHeight();    // height of textfield

    scroller = new ScrollableMessagesBox("Messages:", 
                                     width, height-msgTFHeight-20);
       // 20 is for the "Messages:" title and a bit of space

    form.append(msgTF);
    form.append(scroller);

    exitCmd = new Command("Exit", Command.EXIT, 1);
    sendCmd = new Command("Send", Command.SCREEN, 1);
    form.addCommand(exitCmd);
    form.addCommand(sendCmd);

    form.setCommandListener(this);
  }  // end of ScrollMBDemo()


  protected void startApp() 
  { display = Display.getDisplay(this);
    display.setCurrent(form);
  }


  public void commandAction(Command c, Displayable d) 
  {
    if (c == exitCmd)
      destroyApp(true);
    else if (c == sendCmd) {
      String msg = msgTF.getString();
      if ((msg != null) && (!msg.equals("")))
        scroller.addMessage(msg);  // pass the message to ScrollableMessagesBox
    }
  } // end of commandAction()


  protected void destroyApp(boolean unconditional) 
  {  notifyDestroyed(); }

  protected void pauseApp() {}

} // end of ScrollMBDemo class
